Highlights:
   - **Bug fixes**
      - Add argument 'module' to 'warn_explicit' to show the deprecated warning (#6467) (by **Lin Jiang**)
      - Fix cache_loop_invariant_global_vars pass (#6462) (by **Lin Jiang**)
      - Fix memory leak in SPIRV module (#6449) (by **yekuang**)
   - **CUDA backend**
      - Add maximum stack limit to CompileConfig (#6455) (by **Lin Jiang**)
   - **Documentation**
      - Update global_settings.md (#6370) (by **Zhao Liang**)
      - Update global data access rule checker in doc (#6347) (by **Mingrui Zhang**)
   - **Error messages**
      - Shorten traceback for _BoundedDifferentiableMethod (#6475) (by **Lin Jiang**)
      - Return NotImplemented for operations between field and Expr/Matrix/Struct (#6474) (by **Lin Jiang**)
      - Return TaichiTypeError in ASTTransformer when a binary op is not supported (#6477) (by **Lin Jiang**)
      - Deprecate ndrange with number of the loop variables != the dimension of the ndrange (#6422) (by **Lin Jiang**)
      - Add error message when the number of the loop variables does not match the dimension of the ndrange (#6360) (by **Lin Jiang**)
   - **Language and syntax**
      - MatrixType refactor: Support matrix slice (#6430) (by **Yi Xu**)
      - Allow augmented assign on matric slice (#6382) (by **Yi Xu**)
      - Allow filling a field with Expr (#6391) (by **Yi Xu**)
      - Replace matrix warning param by current logging level (#6377) (by **Zhao Liang**)
      - Matrix/Vector refactor: Matrix operations part 1 (#6319) (by **Mike He**)

Full changelog:
   - [lang] MatrixType bug fix: Demote ret_type for ArgLoadStmt after scalarization (#6433) (by **Zhanlue Yang**)
   - [test] MatrixType refactor: Add tests for writing to matrix slice (#6480) (by **Yi Xu**)
   - [Error] Shorten traceback for _BoundedDifferentiableMethod (#6475) (by **Lin Jiang**)
   - [Error] Return NotImplemented for operations between field and Expr/Matrix/Struct (#6474) (by **Lin Jiang**)
   - [Error] Return TaichiTypeError in ASTTransformer when a binary op is not supported (#6477) (by **Lin Jiang**)
   - [ci] Switch linux gpu job to use LLVM 15 (#6465) (by **Ailing**)
   - [aot] Modify aot-demo.sh to track master branch of taichi-aot-demo (#6473) (by **Zhanlue Yang**)
   - [ci] Move implicit fem android demo to master branch (#6463) (by **Ailing**)
   - [aot] Add VkDeviceMemory to TiVulkanMemoryInteropInfo (#6442) (by **Zhanlue Yang**)
   - [aot] Disabled physical storage buffer temporarily (#6468) (by **PENGUINLIONG**)
   - [ci] Add PR tag for amdgpu. (#6466) (by **Zeyu Li**)
   - [Bug] [error] Add argument 'module' to 'warn_explicit' to show the deprecated warning (#6467) (by **Lin Jiang**)
   - [bug] Fix false overflow alarm in struct fors under packed mode (#6457) (by **Yi Xu**)
   - [Bug] Fix cache_loop_invariant_global_vars pass (#6462) (by **Lin Jiang**)
   - [llvm] Fix broken llvm module on CUDA backend when TI_LLVM_15 is on (#6458) (by **Ailing**)
   - Revert "[ci] Add unix end-to-end CI tests for meshtaichi" (#6460) (by **Ailing**)
   - [lang] MatrixType bug fix: support star & loop operations over matrix-typed Expr (#6427) (by **Zhanlue Yang**)
   - [ci] Add unix end-to-end CI tests for meshtaichi (#6453) (by **yixu**)
   - [CUDA] Add maximum stack limit to CompileConfig (#6455) (by **Lin Jiang**)
   - [ci] Swtich CPU jobs to use prebuilt LLVM15 (#6435) (by **Ailing**)
   - [Bug] Fix memory leak in SPIRV module (#6449) (by **yekuang**)
   - [llvm] Allocate RuntimeContext on heap (#6420) (by **Lin Jiang**)
   - [opt] Eliminate redundant mod for SNode access under packed mode (#6444) (by **Yi Xu**)
   - [vulkan] Disable NoSignedWrap decoration on vulkan backend (#6440) (by **Ailing**)
   - [example] Ti-example: phase field simulation of snow growth (#6439) (by **莫翰轩**)
   - [misc] Bump version to v1.2.1 (#6436) (by **Zhanlue Yang**)
   - [Lang] MatrixType refactor: Support matrix slice (#6430) (by **Yi Xu**)
   - [aot] Warns the user when mapping device-only memory (#6417) (by **PENGUINLIONG**)
   - [Error] Deprecate ndrange with number of the loop variables != the dimension of the ndrange (#6422) (by **Lin Jiang**)
   - [aot] Support push_arg for Kernel in C++ wrapper (#6419) (by **Ailing**)
   - [aot] Use count instead of size-in-bytes for ND-array access in C++ wrapper (#6409) (by **PENGUINLIONG**)
   - [aot] Rename incomplete to truncated (#6418) (by **PENGUINLIONG**)
   - [error] Warn Linux users about manylinux2014 build on startup (#6416) (by **Proton**)
   - [vulkan] [bug] Stop using the buffer device address feature on macOS (#6415) (by **Yi Xu**)
   - [aot] Fixed default list (#6403) (by **PENGUINLIONG**)
   - [aot] Device capability refactorization (#6184) (by **PENGUINLIONG**)
   - [bug] Fix flaky test with taichi_sparse_test.cpp (#6400) (by **Zhanlue Yang**)
   - [Lang] Allow augmented assign on matric slice (#6382) (by **Yi Xu**)
   - [Doc] Update global_settings.md (#6370) (by **Zhao Liang**)
   - [example] Change unnecessary ti.ndrange call to range in Karmal vortex example (#6389) (by **Zhao Liang**)
   - [Lang] [bug] Allow filling a field with Expr (#6391) (by **Yi Xu**)
   - [bug] [lang] Fix copyback for fortran contiguous numpy arrays" (#6390) (by **Ailing Zhang**)
   - [lang] Fix from_numpy() for vector field with a non-contiguous array (by **Ailing Zhang**)
   - [Doc] Update global data access rule checker in doc (#6347) (by **Mingrui Zhang**)
   - [lang] Texture format for better expressiveness (#6338) (by **PENGUINLIONG**)
   - [spirv] Fix duplicated interface id for global_tmp buffers (#6392) (by **Ailing**)
   - Revert "[bug] [lang] Fix copyback for fortran contiguous numpy arrays" (#6390) (by **Ailing**)
   - [bug] [lang] Fix copyback for fortran contiguous numpy arrays (#6376) (by **Ailing**)
   - [Lang] Replace matrix warning param by current logging level (#6377) (by **Zhao Liang**)
   - [misc] Tweak CMake clang exec messages (#6379) (by **yekuang**)
   - [lang] Support structured for loop for RW texture (#6336) (by **PENGUINLIONG**)
   - [autodiff] Fix mode capture for validation kernels (#6361) (by **Mingrui Zhang**)
   - [lang] MatrixType bug fix: Support returning an Expr with MatrixType (#6375) (by **Yi Xu**)
   - [lang] MatrixType bug fix: Fix error with print of MatrixType (#6340) (by **Zhanlue Yang**)
   - [autodiff] Add complicated test case for gdar checker (#6366) (by **Mingrui Zhang**)
   - [lang] [refactor] Refine implementation and tests for matrix slice (#6373) (by **Yi Xu**)
   - [lang] MatrixType bug fix: Add support for unpacking Expr with MatrixType (#6341) (by **Zhanlue Yang**)
   - [Lang] Matrix/Vector refactor: Matrix operations part 1 (#6319) (by **Mike He**)
   - [bug] Fix potential bug in #6362 (#6363) (by **Yi Xu**)
   - [mesh] Fix MeshTaichi warnings in CUDA backend (#6369) (by **Chang Yu**)
   - [bug] Fix returning uint64 as signed integer (#6364) (by **Lin Jiang**)
   - [doc] Update doc about how to use vulkan print (#6359) (by **Ailing**)
   - [Error] Add error message when the number of the loop variables does not match the dimension of the ndrange (#6360) (by **Lin Jiang**)
